#include <iostream>
#include <fstream>
#include <ctime>
#include <string>
#include <vector>

using namespace std;

int main(int argc, char* argv[])
{
	string default_filename = "output";
	string filename = "";
	string input;
	string source_folder, dest_folder;

	source_folder = argv[1];
	dest_folder = argv[2];
	input = argv[3];
	filename = argv[4];

	if (argc < 5) 
	{
		cout << "Too few parameters." << endl;

		cout << "USAGE: " << endl;
		cout << "Buildshit.exe [source_folder] [destination_folder] [input: i.e manifest.txt] [batchfile_name]" << endl;
		return(0);
	}

	ofstream myfile;
	ifstream file(input);

	srand(time(0));

	const string phraseList[5] = { "Now with some formatting!", "60% of the time, it works every time.", "ID10T Error", "Take me down to funky town...", "Ryan started the fire!" };

	string phraseoftheday = phraseList[rand() % 5];

	cout << "Buildshit by MrC" << endl;
	cout << phraseoftheday << endl;
	cout << "" << endl;
	
	if (!filename.empty()) {
		cout << "Using filename: " << filename << endl;
	}
	else
	{
		filename = default_filename;
	}

	myfile.open(filename + ".bat");

	vector<string> names;

	while (file >> input)
	{
		names.push_back(input);
	}

	for (string name : names)
	{
		cout << name << endl;

		myfile << "xcopy " << "\"" << source_folder << "\\" << name << "\"" << " " << "\"" << dest_folder << "\\" << name << "*" << "\"" << " /Y /F /D" << endl;

	}
	
	cout << endl;
	cout << filename << ".bat" << " created." << endl;
	cout << endl;

	return 0;
}
